<?php

$ConfigFileName = dirname(__FILE__).'/../config.php';
      
if(file_exists($ConfigFileName)) include_once($ConfigFileName);
  else die('Nenalezen konfigurační soubor '.$ConfigFileName.'!');
  
include_once('Database.php');
include_once('Error.php');
include_once('UTF8.php');
include_once('File.php');
include_once('Page.php');
include_once('Mail.php');
include_once('PrefixMultiplier.php');
include_once('Module.php');
include_once('Model.php');
include_once('XML.php');
include_once('HTML.php');
include_once('XHTML.php');
include_once('URL.php');
include_once('PageList.php');
include_once('TableHeader.php');
include_once('View.php');
include_once('ViewList.php');
include_once('ViewForm.php');
include_once('Types/Type.php');
  

class System extends ModularSystem
{  
  var $Pages = array();
  var $Type;
  var $Style;
  
  function __construct($Database)
  {
    parent::__construct($Database);
    $this->Type = new Type($this); 
  }
  
  function HumanDate($Time)
  {
    return(date('j.n.Y', $Time));
  }
  
  function Link($Target)
  {
    global $Config;
   
    return($Config['Web']['RootFolder'].$Target);
  }     
}

function GlobalInit()
{
  global $Config, $Database, $System, $ScriptTimeStart, $ConfigFileName;
  
  $ScriptTimeStart = GetMicrotime();
  // SQL injection hack protection
  foreach($_POST as $Index => $Item) $_POST[$Index] = addslashes($Item);
  foreach($_GET as $Index => $Item) $_GET[$Index] = addslashes($Item);

  if(isset($_SERVER['REMOTE_ADDR'])) session_start();

  $Database = new Database($Config['Database']['Host'], $Config['Database']['User'], $Config['Database']['Password'], $Config['Database']['Database']);
  $Database->Prefix = $Config['Database']['Prefix'];
  $Database->charset($Config['Database']['Charset']);
  $Database->ShowSQLError = $Config['Web']['ShowSQLError'];
  $Database->ShowSQLQuery = $Config['Web']['ShowSQLQuery'];

  $System = new System($Database);
  $System->Style = $Config['Web']['Style'];
  $System->RootFolder = $Config['Web']['RootFolder'];
  $System->Config = &$Config;
}

$MonthNames = array('', 'Leden', 'Únor', 'Březen', 'Duben', 'Květen', 'Červen', 'Červenec', 'Srpen', 'Září', 'Říjen', 'Listopad', 'Prosinec');

$UnitNames = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB');
 
function HumanSize($Value)
{
  global $UnitNames;

  $UnitIndex = 0;
  while($Value > 1024)
  {
    $Value = round($Value / 1024, 3);
    $UnitIndex++;
  }
  return($Value.' '.$UnitNames[$UnitIndex]);
}

function GetMicrotime()
{
  list($Usec, $Sec) = explode(' ', microtime());
  return ((float)$Usec + (float)$Sec);
}

function ShowArray($Pole)
{
  echo('<pre style="font-size: 8pt;">');
  print_r($Pole);
  echo('</pre>');
}

function TimeToMysqlDateTime($Time)
{
  return(date('Y-m-d H:i:s', $Time));  
}

function MysqlDateTimeToTime($Time)
{
  $Parts = explode(' ', $Time);
  $DateParts = explode('-', $Parts[0]); 
  $TimeParts = explode(':', $Parts[1]);
  $Result = mktime($TimeParts[0], $TimeParts[1], $TimeParts[2], $DateParts[1], $DateParts[2], $DateParts[0]); 
  return($Result);  
}

function MysqlDateToTime($Time)
{
  return(MysqlDateTimeToTime($Time.' 0:0:0'));  
}

function HumanDate($Time)
{
  $Date = explode(' ', $Time);
  $Parts = explode('-', $Date[0]);
  if($Date != '0000-00-00') return(($Parts[2]*1).'.'.($Parts[1]*1).'.'.$Parts[0]);
  else return('&nbsp;');
}

// Zobrazení číselný seznamu stránek
function PagesList($URL, $Page, $TotalCount, $CountPerPage)
{
  $Count = ceil($TotalCount / $CountPerPage);
  $Around = 10;
  $Result = '';
  if($Count>1)
  {
    if($Page>0) 
    {
      $Result.= '<a href="'.$URL.'0">&lt;&lt;</a> ';
      $Result.= '<a href="'.$URL.($Page-1).'">&lt;</a> ';
    }
    $PagesMax = $Count-1;
    $PagesMin = 0;
    if($PagesMax>($Page+$Around)) $PagesMax = $Page+$Around;
    if($PagesMin<($Page-$Around))
    {
      $Result.= ' .. ';
      $PagesMin = $Page-$Around;
    }
    for($i=$PagesMin;$i<=$PagesMax;$i++)
    {
      if($i==$Page) $Result.= '<strong>';
      $Result.= '<a href="'.$URL.$i.'">'.($i+1).'</a> ';
      if($i==$Page) $Result.= '</strong>';
    } 
    if($PagesMax<($Count-1)) $Result .= ' .. ';
    if($Page<($Count-1)) 
    {
      $Result.= '<a href="'.$URL.($Page+1).'">&gt;</a> ';
      $Result.= '<a href="'.$URL.($Count-1).'">&gt;&gt;</a>';
    }
  }
  return($Result);
} 

function GetQueryStringArray($QueryString)
{
  $Result = array();
  $Parts = explode('&', $QueryString);
  foreach($Parts as $Part)
  {
    if($Part != '')
    {
      if(!strpos($Part, '=')) $Part .= '=';
      $Item = explode('=', $Part);
      $Result[$Item[0]] = $Item[1];
    }
  }
  return($Result);
}

function SetQueryStringArray($QueryStringArray)
{
  $Parts = array();
  foreach($QueryStringArray as $Index => $Item)
  {
    $Parts[] = $Index.'='.$Item;
  }
  return(implode('&', $Parts));
}

function GetPageList($TotalCount)
{
  global $System;
    
  $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
  
  $ItemPerPage = $System->Config['Web']['ItemsPerPage'];
  $Around = round($System->Config['Web']['VisiblePagingItems'] / 2);
  $Result = '';
  $PageCount = floor($TotalCount / $ItemPerPage) + 1;
  
  if(!array_key_exists('Page', $_SESSION)) $_SESSION['Page'] = 0;
  if(array_key_exists('page', $_GET)) $_SESSION['Page'] = $_GET['page'] * 1;
  if($_SESSION['Page'] < 0) $_SESSION['Page'] = 0;
  if($_SESSION['Page'] >= $PageCount) $_SESSION['Page'] = $PageCount - 1;
  $CurrentPage = $_SESSION['Page'];
  
        
  $Result .= 'Počet položek: <strong>'.$TotalCount.'</strong> &nbsp; Stránky: ';

  $Result = '';
  if($PageCount > 1)
  {
    if($CurrentPage > 0) 
    {
      $QueryItems['page'] = 0;      
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&lt;&lt;</a> ';
      $QueryItems['page'] = ($CurrentPage - 1);
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&lt;</a> ';
    }
    $PagesMax = $PageCount - 1;
    $PagesMin = 0;
    if($PagesMax > ($CurrentPage + $Around)) $PagesMax = $CurrentPage + $Around;
    if($PagesMin < ($CurrentPage - $Around))
    {
      $Result.= ' ... ';
      $PagesMin = $CurrentPage - $Around;
    }
    for($i = $PagesMin; $i <= $PagesMax; $i++)
    {
      if($i == $CurrentPage) $Result.= '<strong>'.($i + 1).'</strong> ';
      else {
       $QueryItems['page'] = $i;
       $Result .= '<a href="?'.SetQueryStringArray($QueryItems).'">'.($i + 1).'</a> ';
      }
    } 
    if($PagesMax < ($PageCount - 1)) $Result .= ' ... ';
    if($CurrentPage < ($PageCount - 1)) 
    {
      $QueryItems['page'] = ($CurrentPage + 1);
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&gt;</a> ';
      $QueryItems['page'] = ($PageCount - 1);
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&gt;&gt;</a>';
    }
  }
  $Result = '<div style="text-align: center">'.$Result.'</div>';
  return(array('SQLLimit' => ' LIMIT '.$CurrentPage * $ItemPerPage.', '.$ItemPerPage, 
    'Page' => $CurrentPage,
    'Output' => $Result,
  ));
}

$OrderDirSQL = array('ASC', 'DESC');
$OrderArrowImage = array('sort_asc.png', 'sort_desc.png');

function GetOrderTableHeader($Columns, $DefaultColumn, $DefaultOrder = 0)
{
  global $OrderDirSQL, $OrderArrowImage, $Config, $System;
  
  if(array_key_exists('OrderCol', $_GET)) $_SESSION['OrderCol'] = $_GET['OrderCol'];
  if(array_key_exists('OrderDir', $_GET)) $_SESSION['OrderDir'] = $_GET['OrderDir'];
  if(!array_key_exists('OrderCol', $_SESSION)) $_SESSION['OrderCol'] = $DefaultColumn;
  if(!array_key_exists('OrderDir', $_SESSION)) $_SESSION['OrderDir'] = $DefaultOrder;
  
  // Check OrderCol
  $Found = false;
  foreach($Columns as $Column)
  {
    if($Column['Name'] == $_SESSION['OrderCol'])
    {
      $Found = true;    
      break;
    }
  }
  if($Found == false)
  {
    $_SESSION['OrderCol'] = $DefaultColumn;
    $_SESSION['OrderDir'] = $DefaultOrder;
  }
  // Check OrderDir
  if(($_SESSION['OrderDir'] != 0) and ($_SESSION['OrderDir'] != 1)) $_SESSION['OrderDir'] = 0;
  
  $Result = '';
  $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
  foreach($Columns as $Index => $Column)
  {
    $QueryItems['OrderCol'] = $Column['Name'];
    $QueryItems['OrderDir'] = 1 - $_SESSION['OrderDir'];
    if($Column['Name'] == $_SESSION['OrderCol']) $ArrowImage = '<img style="vertical-align: middle; border: 0px;" src="'.$System->Link('/images/'.$OrderArrowImage[$_SESSION['OrderDir']]).'" alt="order arrow">';
      else $ArrowImage = '';
    if($Column['Name'] == '') $Result .= '<th>'.$Column['Title'].'</th>';
      else $Result .= '<th><a href="?'.SetQueryStringArray($QueryItems).'">'.$Column['Title'].$ArrowImage.'</a></th>';
  }
  return(array(
    'SQL' => ' ORDER BY `'.$_SESSION['OrderCol'].'` '.$OrderDirSQL[$_SESSION['OrderDir']],
    'Output' => '<tr>'.$Result.'</tr>',
    'Column' => $_SESSION['OrderCol'],
    'Direction' => $_SESSION['OrderDir'],
  ));
}
function GetRemoteAddress()
{
  if(array_key_exists('HTTP_X_FORWARDED_FOR',$_SERVER)) $IP = $_SERVER['HTTP_X_FORWARDED_FOR'] ;
  else if(array_key_exists('REMOTE_ADDR', $_SERVER)) $IP = $_SERVER['REMOTE_ADDR'];
  else $IP = '0.0.0.0';
  return($IP);
}

function IsInternetAddr()
{
  $RemoteAddr = GetRemoteAddress();
  $RemoteAddr = explode('.', $RemoteAddr);
//  return(!(($RemoteAddr[0] == 10) and ($RemoteAddr[1] == 145)));
  return(!(($RemoteAddr[0] == 10)));
}

function GetMemberByIP($IP)
{
  global $Database;
  
  $DbResult = $Database->query('SELECT Id FROM Member WHERE (SELECT Member FROM NetworkDevice WHERE (SELECT Device FROM NetworkInterface WHERE LocalIP = "'.$IP.'") = NetworkDevice.Id) = Member.Id');
  if($DbResult->num_rows > 0)
  {
    $DbRow = $DbResult->fetch_assoc();  
    return($DbRow['Id']);
  } else return('');
}

function RemoveDiacritic($Text)
{
  return(str_replace(
    array('á', 'č', 'ď', 'é', 'ě', 'í', 'ľ', 'ň', 'ó', 'ř', 'š', 'ť', 'ú', 'ů', 'ý', 'ž', 'Á', 'Č', 'Ď', 'É', 'Ě', 'Í', 'Ľ', 'Ň', 'Ó', 'Ř', 'Š', 'Ť', 'Ú', 'Ů', 'Ý', 'Ž'),
    array('a', 'c', 'd', 'e', 'e', 'i', 'l', 'n', 'o', 'r', 's', 't', 'u', 'u', 'y', 'z', 'A', 'C', 'D', 'E', 'E', 'I', 'L', 'N', 'O', 'R', 'S', 'T', 'U', 'U', 'Y', 'Z'), 
    $Text));
}

function RouterOSIdent($Name)
{
  return(strtr(strtolower(trim($Name)), array(' ' => '-', '.' => '', '(' => '-', ')' => '-',
  'č' => 'c', 'š' => 's', 'ě' => 'e', 'ř' => 'r', 'ž' => 'z', 'ý' => 'y', 'á' => 'a', 'í' => 'i', 'é' => 'e', 'ů' => 'u', 'ú' => 'u', 'ď' => 'd', 'ť' => 't', 'ň' => 'n', 'ó' => 'o',
  'Č' => 'c', 'Š' => 's', 'Ě' => 'e', 'Ř' => 'r', 'Ž' => 'z', 'Ý' => 'y', 'Á' => 'a', 'Í' => 'i', 'É' => 'e', 'Ů' => 'u', 'Ú' => 'u', 'Ď' => 'd', 'Ť' => 't', 'Ň' => 'n', 'Ó' => 'o',
)));
}

function NotBlank($Text)
{
  if($Text == '') return('&nbsp'); 
    else return($Text);
}

function strip_cdata($string)
{
  preg_match_all('/<!\[cdata\[(.*?)\]\]>/is', $string, $matches);
  return str_replace($matches[0], $matches[1], $string);
} 

function html2txt($document)
{
  $search = array('@<script[^>]*?>.*?</script>@si',  // Strip out javascript
               '@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags
               '@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
               '@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments including CDATA
  );
  $text = preg_replace($search, '', $document);
  return $text;
} 

function DebugLog($Text)
{
  global $Config;
  
  if($Config['Web']['ShowDebug']) 
  {
    if(isset($_SERVER['REMOTE_ADDR'])) $Ending = '<br/>'."\n";
      else $Ending = "\n";
      echo('Log: '.$Text.$Ending);
  }
}

function ProcessURL()
{
  if(array_key_exists('REDIRECT_QUERY_STRING', $_SERVER))
    $PathString = $_SERVER['REDIRECT_QUERY_STRING'];
    else $PathString = '';
  if(substr($PathString, -1, 1) == '/') $PathString = substr($PathString, 0, -1);
  //echo('"'.$QueryString.'"');
  $PathItems = explode('/', $PathString);
  if(strpos($_SERVER['REQUEST_URI'], '?') !== false)
    $_SERVER['QUERY_STRING'] = substr($_SERVER['REQUEST_URI'], strpos($_SERVER['REQUEST_URI'], '?') + 1);
    else $_SERVER['QUERY_STRING'] = '';    
  parse_str($_SERVER['QUERY_STRING'], $_GET);
  return($PathItems);
}

?>
