<?php

define('PropertyInteger8', 'Integer8');
define('PropertyInteger16', 'Integer16');
define('PropertyInteger24', 'Integer24');
define('PropertyInteger32', 'Integer32');
define('PropertyInteger64', 'Integer64');

define('PropertyText8', 'Text8');
define('PropertyText16', 'Text16');
define('PropertyText24', 'Text24');
define('PropertyText32', 'Text32');

define('PropertyDate', 'Date');
define('PropertyTime', 'Time');
define('PropertyDateTime', 'DateTime');
define('PropertyText', 'Text16');
define('PropertyString', 'String');
define('PropertyBoolean', 'Boolean');
define('PropertyInteger', 'Integer32');
define('PropertyFloat', 'Float');
define('PropertyDouble', 'Double');
define('PropertyOneToMany', 'OneToMany');
define('PropertyManyToMany', 'ManyToMany');


class Model 
{
  var $Database;    
  var $Name;
  var $Properties;
  var $System;
  var $Module;
  var $Installed;
  var $Parent;
  
  function __construct($Database, $System)
  {
    $this->Database = &$Database;
    $this->System = &$System;
    $this->AddPropertyOneToMany('ItemOwnerModule', 'SystemModule', true);
    $this->AddPropertyDateTime('ItemTimeCreate', true);
    $this->AddPropertyOneToMany('ItemUserCreate', 'User', true);
    $this->AddPropertyDateTime('ItemTimeModify', true);
    $this->AddPropertyOneToMany('ItemUserModify', 'User', true);   
  }
  
  function AddPropertyDateTime($Name, $Null = false)
  {
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyDateTime, 
      'Null' => $Null); 
  }
  
  function AddPropertyDate($Name, $Null = false)
  {
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyDate,
      'Null' => $Null); 
  }
  
  function AddPropertyTime($Name, $Null = false)
  {
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyTime,
      'Null' => $Null); 
  }
  
  function AddPropertyOneToMany($Name, $TargetModel, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyOneToMany, 
      'TargetModel' => $TargetModel, 'Null' => $Null); 
  }
  
  function AddPropertyText($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyText,
      'Null' => $Null); 
  }

  function AddPropertyText8($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyText8,
      'Null' => $Null); 
  }

  function AddPropertyText16($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyText16,
      'Null' => $Null); 
  }

  function AddPropertyText24($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyText24,
      'Null' => $Null); 
  }

  function AddPropertyText32($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyText32,
      'Null' => $Null); 
  }

  function AddPropertyString($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyString,
      'Null' => $Null); 
  }

  function AddPropertyInteger($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyInteger,
      'Null' => $Null); 
  }

  function AddPropertyInteger8($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyInteger8,
      'Null' => $Null); 
  }

  function AddPropertyInteger16($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyInteger16,
      'Null' => $Null); 
  }

  function AddPropertyInteger24($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyInteger24,
      'Null' => $Null); 
  }

  function AddPropertyInteger32($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyInteger32,
      'Null' => $Null); 
  }

  function AddPropertyInteger64($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyInteger64,
      'Null' => $Null); 
  }

  function AddPropertyFloat($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyFloat,
      'Null' => $Null); 
  }

  function AddPropertyDouble($Name, $Null = false)
  {      
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyDouble,
      'Null' => $Null); 
  }

  function AddPropertyBoolean($Name, $Null = false)
  {
    $this->Properties[] = array('Name' => $Name, 'Type' => PropertyBoolean,
      'Null' => $Null); 
  }
 
  function AddPropertyManyToMany($TargetModel, $Relation, $ColumnOwn, $ColumnTarget, $Null = false)
  {      
    $this->Properties[] = array('Type' => PropertyManyToMany, 
      'TargetModel' => $TargetModel, 'Name' => $Relation, 'ColumnOwn' => $ColumnOwn,
      'ColumnTarget' => $ColumnTarget, 'Null' => $Null); 
  }
  
  function Install()
  {
    if($this->Installed) return;
    $this->Installed = true;
    $this->Database->insert('SystemModel', array('Name' => $this->Name, 'Module' => $this->Module->Id));
    $this->Id = $this->Database->insert_id;
    
    $Query = 'CREATE TABLE IF NOT EXISTS `'.$this->Name.'` ('.
      '`Id` int(11) NOT NULL AUTO_INCREMENT,';
    foreach($this->Properties as $Property)
    {
      $this->Database->insert('SystemModelProperty', array('Name' => $Property['Name'], 
        'Model' => $this->Id, 'Type' => $Property['Type']));
      if($Property['Null']) $Null = 'NULL';
        else $Null = 'NOT NULL';
      $Null = 'NULL';
      if($Property['Type'] == PropertyDateTime) 
        $Query .= '`'.$Property['Name'].'` DATETIME '.$Null.',';
      else if($Property['Type'] == PropertyDate) 
        $Query .= '`'.$Property['Name'].'` DATE '.$Null.',';
      else if($Property['Type'] == PropertyTime) 
        $Query .= '`'.$Property['Name'].'` TIME '.$Null.',';
      else if($Property['Type'] == PropertyString) 
        $Query .= '`'.$Property['Name'].'` VARCHAR(255) COLLATE utf8_general_ci '.$Null.',';
      else if($Property['Type'] == PropertyText8) 
        $Query .= '`'.$Property['Name'].'` TINYTEXT COLLATE utf8_general_ci '.$Null.',';
      else if($Property['Type'] == PropertyText16) 
        $Query .= '`'.$Property['Name'].'` TEXT COLLATE utf8_general_ci '.$Null.',';
      else if($Property['Type'] == PropertyText24) 
        $Query .= '`'.$Property['Name'].'` MEDIUMTEXT COLLATE utf8_general_ci '.$Null.',';
      else if($Property['Type'] == PropertyText32) 
        $Query .= '`'.$Property['Name'].'` LONGTEXT COLLATE utf8_general_ci '.$Null.',';
      else if($Property['Type'] == PropertyInteger8) 
        $Query .= '`'.$Property['Name'].'` TINYINT(4) '.$Null.',';
      else if($Property['Type'] == PropertyInteger16) 
        $Query .= '`'.$Property['Name'].'` SMALLINT(6) '.$Null.',';
      else if($Property['Type'] == PropertyInteger24) 
        $Query .= '`'.$Property['Name'].'` MEDIUMINT(9) '.$Null.',';
      else if($Property['Type'] == PropertyInteger32) 
        $Query .= '`'.$Property['Name'].'` INT(11) '.$Null.',';
      else if($Property['Type'] == PropertyInteger64) 
        $Query .= '`'.$Property['Name'].'` BIGINT(20) '.$Null.',';
      else if($Property['Type'] == PropertyBoolean) 
        $Query .= '`'.$Property['Name'].'` BOOLEAN '.$Null.',';
      else if($Property['Type'] == PropertyFloat) 
        $Query .= '`'.$Property['Name'].'` FLOAT '.$Null.',';
      else if($Property['Type'] == PropertyDouble) 
        $Query .= '`'.$Property['Name'].'` DOUBLE '.$Null.',';
      else if($Property['Type'] == PropertyOneToMany) 
        $Query .= '`'.$Property['Name'].'` INT(255)'.$Null.','.
          'KEY `'.$Property['Name'].'` (`'.$Property['Name'].'`),';
      else if($Property['Type'] == PropertyManyToMany) ;
        // Create many-to-many table
        //$Query .= '`'.$Property['Name'].'` INT(255) NOT NULL,'.
        //  'KEY `'.$Property['Name'].'` (`'.$Property['Name'].'`),';
      
    }
    $Query .= 'PRIMARY KEY (`Id`)'.
      ') ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;';          
    $this->Database->query($Query);
    foreach($this->Properties as $Property)
    {
      if($Property['Type'] == PropertyOneToMany) 
      {
        if(array_key_exists($Property['TargetModel'], $this->Module->Models))
        {
          if(!$this->Module->Models[$Property['TargetModel']]->Installed)
            $this->Module->Models[$Property['TargetModel']]->Install();
        }
        $this->Database->query('ALTER TABLE `'.$this->Name.'` ADD CONSTRAINT `'.
          $this->Name.'_ibfk_'.$Property['Name'].'` FOREIGN KEY (`'.$Property['Name'].'`) REFERENCES `'.$Property['TargetModel'].'` (`Id`);');
      }
    }  }
    
  function UnInstall()
  {
    foreach($this->Properties as $Property)
    {
      if($Property['Type'] == PropertyManyToMany)
        ; // Delete many-to-many table
      else 
      {if($Property['Type'] == PropertyOneToMany) 
        $this->Database->query('ALTER TABLE `'.$this->Name.'` DROP FOREIGN KEY `'.
          $this->Name.'_ibfk_'.$Property['Name'].'`');
      echo('ss');
      }
    }
    //$this->Database->query('DROP TABLE IF EXISTS `'.$this->Name.'`');
    $this->Installed = false;
  }
}

?>
